/*
 * Segment 2 (KEx),  SWE 2.1 LMS
 * Copyright (C) 2007 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.kex.lms.vew.daten;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.kex.lms.vew.RDSException;

/**
 * Repr&auml;sentiert ein mehrwertiges RDS-Infoelement.
 *
 * @author BitCtrl Systems GmbH, Gieseler
 */

public class RDSZustand extends RDSInteger {

	/**
	 * Erzeugt ein neues Objekt.
	 *
	 * @param xmlName
	 *            Name des XML-ELementes
	 * @param davName
	 *            Name des DAV-Attributes
	 */
	public RDSZustand(final String xmlName, final String davName) {
		super(xmlName, davName);
	}

	@Override
	public void setDavDaten(final Data davdata) throws RDSException {
		if (davdata.isPlain()) {
			davdata.asUnscaledValue().set(wert);
		} else {
			davdata.getUnscaledValue(getDavAttributName()).set(wert);

			if (!davdata.getUnscaledValue(getDavAttributName()).isState()) {
				throw new RDSException("Der Wert '" + wert + "' für das Attribut '" + getDavAttributName()
				+ "' kann nicht auf einen Zustand abgebildet werden");
			}
		}
	}
}
